//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_debug.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2013,2014
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

extern char debug_output_string[300];					// ist in delib_debug.cpp deklariert
extern char debug_output_string_function_name[300];
extern char debug_output_string_program_name[300];
extern char debug_output_format[300];
extern bool debug_output_new_function;

#define DEBUG_COLL_CNT_MAX	200
extern char debug_coll_buffer[DEBUG_COLL_CNT_MAX][200];
extern unsigned long debug_cnt;
extern unsigned long debug_coll_lcnt;

#ifndef __linux__
extern void OutputDebugString_x64(char * msg);
#endif

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#include "library/vc/deditec_string_utils.h"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#if (_MSC_VER >= 1500)	// >= Visual Studio 2008
	#define sprintf	sprintf_s
#endif

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#if (_MSC_VER >= 1500)	// >= Visual Studio 2008
	#define	debug_out(msg)	{OutputDebugString_x64(msg);}
#else
	#define	debug_out(msg)	OutputDebugString(msg)
#endif


#if (_MSC_VER >= 1500)	// >= Visual Studio 2008
	#define STERN_STRING		("(x64) ************64BIT*********************64BIT*******************64BIT***************")
#else
	#define STERN_STRING		("(32Bit) ********************************************************************************")
#endif


//versionNr_0

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define RETURN_OK_ERROR_AS_STRING					ret==RETURN_OK?"RETURN_OK":"RETURN_ERROR"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#ifndef PROGRAM_NAME_IGNORE
	#define PROGRAM_NAME		((char*) DapiHandle->ProgramName)
#else
	#ifdef PROGRAM_NAME_INTERN
		#define PROGRAM_NAME		PROGRAM_NAME_INTERN
	#else
		#define PROGRAM_NAME		""
	#endif
#endif
	
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DEBUG_OUTPUT_FORMAT				"%-30s|%-11s|"
#define debug_set_function_name(x)		if(strcmp(debug_output_string_function_name, x) != 0)\
										{{\
										debug_output_new_function = true;\
										strcpy_n(debug_output_string_function_name, 300, x, strlen_n(x, -1));\
										strcpy_n(debug_output_string_program_name,  300, PROGRAM_NAME, strlen_n(PROGRAM_NAME, -1));\
										}}


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------


// DELIB ---------------
// DELIB ---------------
// DELIB ---------------

#define debug_make_debug_output_string(x)	{\
									strcpy_n(debug_output_string, sizeof(debug_output_string), "|DELIB|", sizeof("|DELIB|"));\
									sprintf(debug_output_format, DEBUG_OUTPUT_FORMAT, debug_output_string_function_name, debug_output_string_program_name);\
									strcat_n(debug_output_string, sizeof(debug_output_string), debug_output_format, sizeof(debug_output_format));\
									strcat_n(debug_output_string, sizeof(debug_output_string), x, (unsigned long) strlen_n(x, -1));\
									}


#ifdef __linux__
	// --------------------------------
	// debug_log
	#define debug_log(x)\
	{\
		debug_make_debug_output_string(x);\
		log_init("DELIB", 0);\
		log_write(debug_output_string, 0);\
	}
	
	#ifndef DEBUG_OUTPUT_TO_LOG
		// --------------------------------
		// debug_error
		#define debug_out_error(x)\
		{\
			debug_make_debug_output_string(x);\
			printf("%s\n", debug_output_string);\
		}
		// --------------------------------
		// debug_info
		#define debug_out_info(x)\
		{\
			debug_make_debug_output_string(x);\
			printf("%s\n", debug_output_string);\
		}
		// --------------------------------
		// debug_print
		#define debug_out_print(x)\
		{\
			debug_make_debug_output_string(x);\
			printf("%s\n", debug_output_string);\
		}
	#else
		#define debug_error(x) debug_log(x)
		#define debug_info(x) debug_log(x)
		#ifdef DEBUG_OUTPUT
			#define debug_print(x) debug_log(x)
		#else
			#define debug_print(x)	{}
		#endif
	#endif
	
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------	
#else
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
	

	
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
#endif

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#ifndef DEBUG_OUTPUT_TO_LOG
	#ifdef DEBUG_OUTPUT 
		// NICHT sammeln....direkt ausgeben         
		#define debug_collect_init()		{debug_coll_lcnt=0;}
		#define debug_collect(x)			{debug_print(x);}
		#define debug_collect_printall()	{}
	#else         
		// Alles sammeln....nur bei einem Fehler ausgeben
		#define debug_collect_init()		{debug_coll_lcnt=0;}
		#define debug_collect(x)			{strcpy_n(debug_coll_buffer[debug_coll_lcnt], sizeof(debug_coll_buffer[debug_coll_lcnt]), x, sizeof(x));  if(debug_coll_lcnt < (DEBUG_COLL_CNT_MAX-1)) {debug_coll_lcnt++;}}
		#define debug_collect_printall()	{\
												for(debug_cnt=0;debug_cnt!=debug_coll_lcnt;debug_cnt++)\
												{\
													debug_print(debug_coll_buffer[debug_cnt]);\
												}\
											}
	#endif 
#else
	#define debug_collect_init()		{}
	#define debug_collect(x)			debug_print(x)
	#define debug_collect_printall()	{}
#endif

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
