//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_open_close.cpp
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2013
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// DEBUG OUTPUT 
//#define DEBUG_OUTPUT		1				// Ausgabe aktivieren (nur fr diese CPP-Datei)
// ACHTUNG !!!! - DAS IST HIER NICHT realisiert .....DEBUG_OUTPUT wird hier nicht benutzt !
// ------------------------------------

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// check_module_config
// DapiInternGetBusType
// DapiCheckHandle
// DapiOpenModuleIntern
// DapiOpenModule
// DapiOpenModuleEx
// DapiCloseModule
// DapiGetDELIBVersion
// DapiInternCloseAllSubmodules


#define PROGRAM_NAME_IGNORE			1
#define PROGRAM_NAME_INTERN			"DeLibIntern"

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>
#include <string.h>        // memset()
#include "malloc.h"

#include "proj_config.h"

#ifdef __linux__
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------
	#ifdef USE_FTDI
		#include "../usb-simple/ftd2xx.h"
	#endif

	#include "library/embedded/dt_communication_paramams.h"
	#include "library/delib/delib.h"
	#include "library/delib/delib_intern.h"
#else
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
	#include <windows.h>
//	#include "conio.h"
	#include "library/delib/delib.h"
	#include "library/ftdi/ftd2xx.h"
	#include "library/embedded/dt_communication_paramams.h"
	#include "library/delib/delib_intern.h"
	#include "delib_io_seriellCOM.h"
	#include "delib_io_ftdi.h"
	#include "delib_set_get_error.h"
	#include "delib_io_tcp.h"
	#include "delib_open_close.h"

	extern DAPI_HANDLE*  DAPI_FUNCTION_PRE  HandleMGR_get_handle_pointer(ULONG module, ULONG nr, ULONG subdevice);
#endif

// ------------------------------------
// ------------------------------------
// DELIB-DEBUG
// ------------------------------------
// ------------------------------------
//
// Function															Windows (DEBUGVIEW)			Linux
// -------------------------										----------------------		-------------------------
// DapiSetError(debug_msg)											immer						immer
// debug_error(debug_msg)											immer						immer
// debug_info(debug_msg)											immer						nur bei DEBUG_OUTPUT
// debug_print(debug_msg)											nur bei DEBUG_OUTPUT		nur bei DEBUG_OUTPUT

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG check_module_config(unsigned long handle)
{
	DAPI_MODULE_PARAMS *DapiModuleParams;
	char debug_msg[200];

	DAPI_HANDLE *DapiHandle;
	DapiHandle = (DAPI_HANDLE*) handle;
	DapiModuleParams = (DAPI_MODULE_PARAMS *) DapiHandle->addr_dapi_module_params;


	// ----------------------------------------------------
	// check module config
	
	sprintf(debug_msg,"check_module_config - wird nun durchgefhrt.................................");
	debug_info(debug_msg);

	// sw_feature1 + hw_interface1
	DapiModuleParams->sw_feature1 = 		DapiReadLong(handle, 0xff30);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->hw_interface1 = 		DapiReadLong(handle, 0xff34);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	// count of channel
	DapiModuleParams->anz_do = 				DapiReadWord(handle, 0xff00);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_di = 				DapiReadWord(handle, 0xff02);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_di_ff = 			DapiReadWord(handle, 0xff0c);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_di_counter = 		DapiReadWord(handle, 0xff0e);	if(DapiGetLastError() != 0) return RETURN_ERROR;
	DapiModuleParams->anz_dx = 				DapiReadWord(handle, 0xff04);
	DapiModuleParams->anz_ao = 				DapiReadWord(handle, 0xff06);
	DapiModuleParams->anz_ai = 				DapiReadWord(handle, 0xff08);
	DapiModuleParams->anz_stepper = 		DapiReadWord(handle, 0xff0a);
	DapiModuleParams->anz_temp = 			DapiReadWord(handle, 0xff10);
	DapiModuleParams->anz_counterin48 = 	DapiReadWord(handle, 0xff12);
	DapiModuleParams->anz_counterout32 = 	DapiReadWord(handle, 0xff14);
	DapiModuleParams->anz_output_pwm = 		DapiReadWord(handle, 0xff16);
	
	// module fw
	DapiModuleParams->fw_version[0] = 		(UCHAR) DapiReadByte(handle, 0xfff4);
	DapiModuleParams->fw_version[1] = 		(UCHAR) DapiReadByte(handle, 0xfff5);
	DapiModuleParams->fw_version[2] = 		(UCHAR) DapiReadByte(handle, 0xfff6);
	DapiModuleParams->fw_version[3] = 		(UCHAR) DapiReadByte(handle, 0xfff7);
	
	DapiModuleParams->sw_class = 			DapiReadLong(handle, 0xfff0);
	DapiModuleParams->hw_group = 			DapiReadLong(handle, 0xffec);

	// DEBUG
	debug_set_function_name("check_module_config");																														debug_info(debug_msg);
	debug_info("-----");
	if (DapiModuleParams->anz_di != 0) 				{ sprintf(debug_msg,"DapiModuleParams->anz_di         = %ld", DapiModuleParams->anz_di); 									debug_info(debug_msg); }
	if (DapiModuleParams->anz_di_counter != 0)		{ sprintf(debug_msg,"DapiModuleParams->anz_di_counter = %ld", DapiModuleParams->anz_di_counter); 					debug_info(debug_msg); }
	if (DapiModuleParams->anz_di_ff != 0)			{ sprintf(debug_msg,"DapiModuleParams->anz_di_ff      = %ld", DapiModuleParams->anz_di_ff); 								debug_info(debug_msg); }
	if (DapiModuleParams->anz_do != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_do         = %ld", DapiModuleParams->anz_do); 									debug_info(debug_msg); }
	if (DapiModuleParams->anz_dx != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_dx         = %ld", DapiModuleParams->anz_dx); 									debug_info(debug_msg); }
	if (DapiModuleParams->anz_ai != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_ai         = %ld", DapiModuleParams->anz_ai); 									debug_info(debug_msg); }
	if (DapiModuleParams->anz_ao != 0)				{ sprintf(debug_msg,"DapiModuleParams->anz_ao         = %ld", DapiModuleParams->anz_ao); 									debug_info(debug_msg); }
	if (DapiModuleParams->anz_stepper != 0)			{ sprintf(debug_msg,"DapiModuleParams->anz_stepper    = %ld", DapiModuleParams->anz_stepper); 							debug_info(debug_msg); }
	if (DapiModuleParams->anz_temp != 0)			{ sprintf(debug_msg,"DapiModuleParams->anz_temp       = %ld", DapiModuleParams->anz_temp); 								debug_info(debug_msg); }
	if (DapiModuleParams->anz_counterin48 != 0)		{ sprintf(debug_msg,"DapiModuleParams->anz_counterin48= %ld", DapiModuleParams->anz_counterin48); 					debug_info(debug_msg); }
	if (DapiModuleParams->anz_counterout32 != 0)	{ sprintf(debug_msg,"DapiModuleParams->anz_counterou32= %ld", DapiModuleParams->anz_counterout32); 				debug_info(debug_msg); }
	if (DapiModuleParams->anz_output_pwm != 0)		{ sprintf(debug_msg,"DapiModuleParams->anz_output_pwm = %ld", DapiModuleParams->anz_output_pwm); 					debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg, "DapiModuleParams->fw_version = %c%c.%c%c", DapiModuleParams->fw_version[0], DapiModuleParams->fw_version[1], DapiModuleParams->fw_version[2], DapiModuleParams->fw_version[3]);	debug_info(debug_msg);
	debug_info("-----");
	sprintf(debug_msg,"DapiModuleParams->sw_feature1 = 0x%lx", DapiModuleParams->sw_feature1);																			debug_info(debug_msg);
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE) != 0)		{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_SUPPORTED_BY_FIRMWARE");		debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_SOFTWARE_FIFO) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_SOFTWARE_FIFO");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DO_CMD_SET_CLR_BIT_32) != 0)	{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DO_CMD_SET_CLR_BIT_32");	debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_EEPROM_RN23) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_EEPROM_RN23");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_DX_1_MODE) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_DX_1_MODE");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_WATCHDOG) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_WATCHDOG");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI_CNT) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI_CNT");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DI_FF) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DI_FF");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DO) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DO");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DO_TIMEOUT) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DO_TIMEOUT");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_PWM_OUT) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_PWM_OUT");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DX) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DX");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_DA) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_DA");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_AD) != 0)						{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_AD");						debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_CNT_OUT32) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_CNT_OUT32");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_CNT_IN48) != 0)				{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_CNT_IN48");				debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_TEMP) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_TEMP");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_feature1 & DAPI_SW_FEATURE_BIT_CFG_STEPPER) != 0)					{ sprintf(debug_msg,"DAPI_SW_FEATURE_BIT_CFG_STEPPER");					debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"DapiModuleParams->hw_interface1 = 0x%lx", DapiModuleParams->hw_interface1);																		debug_info(debug_msg);
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE) != 0)	{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_SUPPORTED_BY_FIRMWARE");		debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) != 0)					{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_ETH");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_CAN) != 0)					{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_CAN");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_RS232) != 0)				{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_RS232");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_RS232_RS485) != 0)			{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_RS232_RS485");			debug_info(debug_msg); }
	if ((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_USB) != 0)					{ sprintf(debug_msg,"DAPI_HW_INTERFACE_BIT_CFG_USB");					debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"sw_feature_type = 0x%lx", DapiModuleParams->sw_class);					debug_info(debug_msg);
	if ((DapiModuleParams->sw_class & DAPI_SW_CLASS_TYPE_OF_MODULE_IDENTIFICATION) != 0)		{ sprintf(debug_msg,"DAPI_SW_CLASS_TYPE_OF_MODULE_IDENTIFICATION");		debug_info(debug_msg); }
	if ((DapiModuleParams->sw_class & DAPI_SW_CLASS_DI_DO_DX_CHANNELS) != 0)					{ sprintf(debug_msg,"DAPI_SW_CLASS_DI_DO_DX_CHANNELS");					debug_info(debug_msg); }
	if ((DapiModuleParams->sw_class & DAPI_SW_CLASS_AD_DA_CHANNELS) != 0)						{ sprintf(debug_msg,"DAPI_SW_CLASS_AD_DA_CHANNELS");						debug_info(debug_msg); }
	debug_info("-----");
	sprintf(debug_msg,"hw_feature_type = 0x%lx", DapiModuleParams->hw_group);					debug_info(debug_msg);
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_RO) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_RO");								debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_LOGICANALYZER) != 0)						{ sprintf(debug_msg,"DAPI_HW_GROUP_LOGICANALYZER");					debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_DI_DO_AD_DA) != 0)							{ sprintf(debug_msg,"DAPI_HW_GROUP_DI_DO_AD_DA");						debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_USB) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_USB");								debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_BS");								debug_info(debug_msg); }
	if ((DapiModuleParams->hw_group & DAPI_HW_GROUP_NET) != 0)									{ sprintf(debug_msg,"DAPI_HW_GROUP_NET");								debug_info(debug_msg); }
	debug_info("-----");
	// -----
	return RETURN_OK;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG DapiInternGetBusType(ULONG moduleID)
{
	ULONG ret;
	char debug_msg[200];

	switch(moduleID)
	{
		// ------------------------------------
		case USB_Interface8:
		case USB_CAN_STICK:
		case USB_LOGI_500:
		case USB_BITP_200:
		case BS_USB_8:				//USB_OPTOIN_8_RELAIS_8:
		case BS_USB_16:				//USB_OPTOIN_16_RELAIS_16:
		case BS_USB_32:				//USB_OPTOIN_32_RELAIS_32:
		case BS_CAN:
			ret = bus_FTDI_DUAL;
			break;
		// ------------------------------------
		case RO_USB1:
			ret = bus_SeriellFTDI;
			break;
		// ------------------------------------
		case RO_SER:
		case BS_SER:
		case RO_CAN:
			ret = bus_SeriellCOM;
			break;
		// ------------------------------------
		case RO_ETH:
		case RO_ETH_LC:
		case BS_ETH:
		case NET_ETH:
			ret = bus_ETH;
			break;
		// ------------------------------------
		case USB_WATCHDOG:
		case USB_MINI_STICK:
		case USB_OPTOIN_8:
		case USB_LOGI_18:
		case USB_SPI_MON:
		case USB_TTL_64:
		case RO_USB2:
		case RO_CAN2:
		case USB_SER_DEBUG:
			ret = bus_FTDI_SINGLE;
			break;
		// ------------------------------------	
		#ifdef __linux__
			case RO_ETH_INTERN:
				ret = bus_ETH_INTERN;
				break;
		#endif
		// ------------------------------------
		default:	
			ret = 0;
			sprintf(debug_msg, "DapiInternGetBusType -> Illegal moduleID (ID=0x%lx)", moduleID);
			DapiSetError(DAPI_ERR_WITH_TEXT, 0, debug_msg, __FILE__, __LINE__);		
			break;
		// ------------------------------------
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG DapiInternGetInterfaceType(ULONG moduleID)
{
	ULONG ret;
	char debug_msg[200];

	switch(moduleID)
	{
		// ------------------------------------
		case USB_Interface8:
		case USB_CAN_STICK:
		case USB_LOGI_500:
		case USB_SER_DEBUG:
		case USB_BITP_200:
		case USB_OPTOIN_8_RELAIS_8:
		case USB_OPTOIN_16_RELAIS_16:
		case USB_OPTOIN_32_RELAIS_32:
		case RO_USB1:
		case USB_WATCHDOG:
		case USB_MINI_STICK:
		case USB_OPTOIN_8:
		case USB_LOGI_18:
		case USB_SPI_MON:
		case USB_TTL_64:
		case RO_USB2:
		case RO_CAN2:
			ret = DAPI_INTERFACE_USB;
			break;
		// ------------------------------------
		case BS_CAN:
		case RO_CAN:
			ret = DAPI_INTERFACE_CAN;
			break;
		// ------------------------------------
		case RO_SER:
		case BS_SER:
			ret = DAPI_INTERFACE_SER;
			break;
		// ------------------------------------
		case RO_ETH:
		case RO_ETH_LC:
		case BS_ETH:
		case NET_ETH:
			ret = DAPI_INTERFACE_ETH;
			break;
		// ------------------------------------
		default:
			ret = DAPI_INTERFACE_UNDEFINED;
			sprintf(debug_msg, "DapiInternGetInterfaceType -> Illegal moduleID (ID=0x%lx)", moduleID);
			DapiSetError(DAPI_ERR_WITH_TEXT, 0, debug_msg, __FILE__, __LINE__);		
			break;
		// ------------------------------------
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternGetModuleName(ULONG moduleID, char* ModName, unsigned long ModNameSize)
{
	char Name[200];
	unsigned long i;
	
	switch(moduleID)
	{
		case USB_Interface8:				sprintf(Name, "USB-Interface8");	break;
		case USB_CAN_STICK:					sprintf(Name, "USB-CAN-Stick");		break;
		case USB_LOGI_500:					sprintf(Name, "USB-LOGI-500");		break;
		case USB_SER_DEBUG:					sprintf(Name, "USB-SER-DEBUG");		break;
		case USB_BITP_200:					sprintf(Name, "USB-BITP-200");		break;
		case USB_OPTOIN_8_RELAIS_8:			sprintf(Name, "BS-USB-8");			break;
		case USB_OPTOIN_16_RELAIS_16:		sprintf(Name, "BS-USB-16");			break;
		case USB_OPTOIN_32_RELAIS_32:		sprintf(Name, "BS-USB-32");			break;
		case BS_CAN:						sprintf(Name, "BS-CAN");			break;
		case RO_USB1:						sprintf(Name, "RO-USB1");			break;
		case RO_SER:						sprintf(Name, "RO-SER");			break;
		case BS_SER:						sprintf(Name, "BS-SER");			break;
		case RO_CAN:						sprintf(Name, "RO-CAN");			break;
		case RO_ETH:						sprintf(Name, "RO-ETH");			break;
		case RO_ETH_LC:						sprintf(Name, "RO-ETH/LC");			break;
		case RO_ETH_INTERN:					sprintf(Name, "RO-ETH-INTERN");		break;
		case BS_ETH:						sprintf(Name, "BS-ETH");			break;
		case NET_ETH:						sprintf(Name, "NET-ETH");			break;
		case USB_WATCHDOG:					sprintf(Name, "USB-Watchdog");		break;
		case USB_MINI_STICK:				sprintf(Name, "USB-Mini-Stick");	break;
		case USB_OPTOIN_8:					sprintf(Name, "USB-OPTOIN-8");		break;
		case USB_LOGI_18:					sprintf(Name, "USB-Logi-18");		break;
		case USB_SPI_MON:					sprintf(Name, "USB-SPI-MON");		break;
		case USB_TTL_64:					sprintf(Name, "USB-TTL-64");		break;
		case RO_USB2:						sprintf(Name, "RO-USB2");			break;
		case RO_CAN2:						sprintf(Name, "RO-CAN2");			break;
		default:							sprintf(Name, "UNKNOWN");			break;
	}
	i=0;
	do
	{
		if(i<ModNameSize) ModName[i] = Name[i];
		++i;
	} while(i <= strlen_n(Name, sizeof(Name)));
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternGetRegistryKeyName(ULONG moduleID, char* ModName, unsigned long ModNameSize)
{
	char Name[200];
	unsigned long i;
	
	switch(moduleID)
	{
		case BS_ETH:						sprintf(Name, "DELIB-CONFIG\\BS-ETH\\Config");		break;
		case BS_SER:						sprintf(Name, "DELIB-CONFIG\\BS-SER\\Config");		break;

		case RO_SER:						sprintf(Name, "DELIB-CONFIG\\RO-SER\\Config");		break;
		case RO_CAN:						sprintf(Name, "DELIB-CONFIG\\RO-CAN\\Config");		break;
		case RO_ETH:						sprintf(Name, "DELIB-CONFIG\\RO-ETH\\Config");		break;
		case RO_ETH_LC:						sprintf(Name, "DELIB-CONFIG\\RO-ETH-LC\\Config");	break;

		case NET_ETH:						sprintf(Name, "DELIB-CONFIG\\NET-ETH\\Config");		break;
		default:							sprintf(Name, "");									break;
	}
	i=0;
	do
	{
		if(i<ModNameSize) ModName[i] = Name[i];
		++i;
	} while(i <= strlen_n(Name, sizeof(Name)));
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

ULONG DapiCheckHandle(ULONG handle)
{
	DAPI_HANDLE *DapiHandle;
	char debug_msg[200];

	if (handle == 0)
	{
		// DEBUG
		debug_set_function_name("DapiCheckHandle");
		sprintf(debug_msg, "********************* HANDLE ID = 0*************");
		debug_error(debug_msg);
		// -----
		return -1;
	}
	
	DapiHandle = (DAPI_HANDLE*) handle;
	
	if(DapiHandle->id != delib_id)
	{
		// DEBUG
		debug_set_function_name("DapiCheckHandle");
		sprintf(debug_msg, "********************* ILLEGAL Handle ID(0x%lx)*************", DapiHandle->id);
		debug_error(debug_msg);
		// -----
		
		return -1;
	}
	
	if((DapiHandle->BusType == bus_FTDI_DUAL) || (DapiHandle->BusType == bus_FTDI_SINGLE))
	{
		if(DapiHandle->ftHandle == 0)
		{
			// DEBUG			
			debug_set_function_name("DapiCheckHandle");
			sprintf(debug_msg, "********************* ILLEGAL ftHandle (=0)*************");
			debug_error(debug_msg);
			// -----
			
			return -1;
		}
	}

	return 0;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long restart_check_module_config(unsigned long handle)
{
	DAPI_HANDLE *DapiHandle;
	DAPI_MODULE_PARAMS *DapiModuleParams;
	char debug_msg[200];
	ULONG ret;
	if((handle==0) || (handle==-1)) 
	{
		return -1;
	}

	DapiHandle = (DAPI_HANDLE*) handle;
	DapiModuleParams = (DAPI_MODULE_PARAMS *) DapiHandle->addr_dapi_module_params;

	ret = check_module_config((unsigned long) DapiHandle);
	
	if(ret==RETURN_ERROR)
	{
		sprintf(debug_msg,"Error reading ModulParams....perhaps Module is not flashed");
		debug_info(debug_msg);

		DapiModuleParams->sw_class			= 0;
		DapiModuleParams->hw_group			= 0;
		DapiModuleParams->sw_feature1		= 0;
		DapiModuleParams->hw_interface1		= 0;
	}

	sprintf(debug_msg,"DapiHandle->moduleID = %ld -> check now some Modules", DapiHandle->moduleID);
	debug_info(debug_msg);

	switch(DapiHandle->moduleID)
	{
		// ----
		case NET_ETH:
			sprintf(debug_msg,"Module to be opened = NET-ETH");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_NET) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_NET not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
		case RO_ETH_LC:
			sprintf(debug_msg,"Module to be opened = RO-ETH/LC");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_RO) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_RO not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
		case BS_ETH:
			sprintf(debug_msg,"Module to be opened = BS-ETH");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			
			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_ETH) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_ETH ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
		case BS_SER:
			sprintf(debug_msg,"Module to be opened = BS-SER");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;

			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_RS232) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_RS232 ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
		// ----
		case BS_CAN:
			sprintf(debug_msg,"Module to be opened = BS-CAN");
			debug_info(debug_msg);
			
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS not set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}

			if((DapiModuleParams->hw_interface1 & DAPI_HW_INTERFACE_BIT_CFG_CAN) == 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_interface1 | DAPI_HW_INTERFACE_BIT_CFG_CAN ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
		// ----
		// ----
		case RO_ETH:
			sprintf(debug_msg,"Module to be opened = RO-ETH");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)		
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
		case RO_SER:
			sprintf(debug_msg,"Module to be opened = RO-SER");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
		case RO_CAN:
			sprintf(debug_msg,"Module to be opened = RO-CAN");
			debug_info(debug_msg);
		
			// Alte RO-Serien haben das Bit nicht gesetzt//check, ob das BS ist
			if((DapiModuleParams->hw_group & DAPI_HW_GROUP_BS) != 0)		
			{
				sprintf(debug_msg,"DapiModuleParams->hw_group | DAPI_HW_GROUP_BS IS set ****** ERROR");
				debug_info(debug_msg);
				return RETURN_ERROR;		// ERROR wird zurckbergeben -> Modul konnte nicht geffnet werden
			}
			break;
		// ----
	}
	return RETURN_OK;
}
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleIntern(ULONG moduleID, ULONG moduleNr, ULONG subdevice, unsigned char* exbuffer, ULONG open_options)
{
	char debug_msg[200];
	ULONG ret;
	ULONG moduleID_copy;
	FT_HANDLE ftHandle;
	DAPI_HANDLE *DapiHandle;
	DAPI_MODULE_PARAMS * DapiModuleParams;
	char moduleName[20];
	
	DapiInternGetModuleName(moduleID, moduleName, sizeof(moduleName));
	
	if(subdevice==DapiModuleID_Device)
	{
		// DEBUG
		debug_set_function_name("DapiOpenModuleIntern");
		sprintf(debug_msg, "DapiOpenModuleIntern(moduleID=0x%lx, (Name=#####  %s  #####) moduleNr=0x%lx, subdevice=%s, exbuffer=0x%lx, open_options=0x%lx) Normal", moduleID, moduleName, moduleNr, subdevice==DapiModuleID_Device?"NormalDevice":"ProgDevice", (unsigned long) exbuffer, open_options);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		// -----
	}
	else
	{
		// DEBUG
		sprintf(debug_msg, "DapiOpenModuleIntern(moduleID=0x%lx, (Name=#####  %s  #####) moduleNr=0x%lx, subdevice=%s, exbuffer=0x%lx, open_options=0x%lx) DEBUGDevice DEBUGDevice DEBUGDevice DEBUGDevice ", moduleID, moduleName, moduleNr, subdevice==DapiModuleID_Device?"NormalDevice":"ProgDevice", (unsigned long) exbuffer, open_options);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		debug_info(debug_msg);
		// -----
	}

	#ifndef __linux__
		DapiHandle = HandleMGR_get_handle_pointer(moduleID, moduleNr&15, subdevice);
	#else
		DapiHandle = malloc(sizeof(DAPI_HANDLE));
		DapiHandle->ftHandle = (FT_HANDLE) -1;
	#endif
	
	DapiHandle->addr_dapi_module_params = (unsigned long) malloc(sizeof(DAPI_MODULE_PARAMS));
	
	if (DapiHandle->addr_dapi_module_params == (unsigned long) NULL)
	{
		sprintf(debug_msg, "malloc() for DapiHandle->addr_dapi_module_params has failed!!");
		DapiSetError(DAPI_ERR_DEVICE_NOT_FOUND, 0, debug_msg, __FILE__, __LINE__);
		
		return 0;
	}

	memset((void*) DapiHandle->addr_dapi_module_params, 0, sizeof(DapiHandle->addr_dapi_module_params));

	DapiModuleParams = (DAPI_MODULE_PARAMS*) DapiHandle->addr_dapi_module_params;
	
	DapiHandle->BusType = DapiInternGetBusType(moduleID);
	if(DapiHandle->BusType == 0)
	{
		// Bus Type nicht vorhanden

		// DEBUG
		debug_set_function_name("DapiOpenModuleIntern");
		sprintf(debug_msg,"Bus Type nicht vorhanden");
		debug_error(debug_msg);
		// -----

		return 0; // 0=Handle = 0-> Error
	}

	// Kann weiter gehen .....
	DapiHandle->id = delib_id;

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// FTDI_DUAL 
	
	#ifdef USE_FTDI_DUAL
		if((DapiHandle->BusType == bus_FTDI_DUAL))
		{
			moduleID_copy = moduleID;
			if((DapiHandle->ftHandle == (FT_HANDLE) -1) || (DapiHandle->id != delib_id))
			{

				// SONDERFALL BS-CAN
				if(moduleID_copy == BS_CAN)
				{
					moduleID_copy = BS_USB_8;
					ret = DapiOpenModuleIntern_FTDI((ULONG) DapiHandle, moduleID_copy, moduleNr, DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
					if(ret==-1)
					{
						moduleID_copy = BS_USB_16;
						ret = DapiOpenModuleIntern_FTDI((ULONG) DapiHandle, moduleID_copy, moduleNr, DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
						if(ret==-1)
						{
							moduleID_copy = BS_USB_32;
							ret = DapiOpenModuleIntern_FTDI((ULONG) DapiHandle, moduleID_copy, moduleNr, DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
						}
					}
				}
				else
				{
					ret = DapiOpenModuleIntern_FTDI((ULONG) DapiHandle, moduleID_copy, moduleNr, DapiHandle->BusType, 1, subdevice, &ftHandle, open_options);	// Retry=1, subdevice
				}
				

				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/FTDI_DUAL");

				sprintf(debug_msg, "ret=%lx", ret);
				debug_info(debug_msg);

				sprintf(debug_msg, "ftHandle=%lx", (ULONG) ftHandle);
				debug_info(debug_msg);
				// -----
				
				if (ret==-1) 
				{
					// DEBUG
					debug_set_function_name("DapiOpenModuleIntern");					
					sprintf(debug_msg,"DapiOpenModuleIntern - return=0");
					debug_info(debug_msg);
					// -----

					DapiSetError(DAPI_ERR_DEVICE_NOT_FOUND, 0, NULL, __FILE__, __LINE__);					

					return 0;
				}
			}
			else
			{
				ftHandle = DapiHandle->ftHandle;
			}
		
			DapiHandle->id = delib_id;
			DapiHandle->moduleID = moduleID_copy;			// Hier muss die evtl. modifizierte Modul-ID rein 
			DapiHandle->moduleNr = moduleNr & 15;
			DapiHandle->ftHandle = ftHandle;
			DapiHandle->SubDevice = subdevice;
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Seriell ber die COM
	
	#ifdef USE_SER
		if(DapiHandle->BusType == bus_SeriellCOM)
		{
			ret = DapiOpenModuleIntern_SeriellCOM((ULONG) DapiHandle, moduleID, moduleNr&15);
			
			if(ret!=0) 
			{	
				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/SeriellCOM");
				sprintf(debug_msg, "DapiOpenModuleIntern - return=0 - No module found");
				debug_error(debug_msg);
				// -----

				DapiSetError(DAPI_ERR_DEVICE_NOT_FOUND, 0, NULL, __FILE__, __LINE__);					

				return 0;	// Connection to Module failed
			}
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Seriell ber FTDI
	
	#ifdef USE_FTDI
		if((DapiHandle->BusType == bus_SeriellFTDI)  || (DapiHandle->BusType == bus_FTDI_SINGLE))
		{
			#ifndef __linux__
				if((DapiHandle->ftHandle == (FT_HANDLE) -1) || (DapiHandle->id != delib_id))
				{
			#endif
				ret = DapiOpenModuleIntern_FTDI((ULONG) DapiHandle, moduleID, moduleNr&15, DapiHandle->BusType, 1, 2, &ftHandle, open_options);	// Retry=1, subdevice=2 (ohne A oder B)

				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/SerFTDI");
				sprintf(debug_msg, "ret=%lx", ret);
				debug_info(debug_msg);
				sprintf(debug_msg, "ftHandle=%lx", (ULONG) ftHandle);
				debug_info(debug_msg);
				// -----
				
				if (ret==-1)
				{
					// DEBUG
					debug_set_function_name("DapiOpenModuleIntern");
					sprintf(debug_msg, "return=0 - No module found");
					debug_error(debug_msg);
					// -----
					
					DapiSetError(DAPI_ERR_DEVICE_NOT_FOUND, 0, NULL, __FILE__, __LINE__);					

					return 0;
				}

			#ifndef __linux__
				}
				else
				{
					ftHandle = DapiHandle->ftHandle;
				}
			#endif	
			
			DapiHandle->id = delib_id;
			DapiHandle->moduleID = moduleID;
			DapiHandle->moduleNr = moduleNr & 15;
			DapiHandle->ftHandle = ftHandle;
			DapiHandle->SubDevice = 2;//subdevice;
			DapiHandle->RS485_ModuleNr = 0;
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet
	
	#ifdef USE_ETH
		if(DapiHandle->BusType == bus_ETH)
		{
			ret = DapiOpenModuleIntern_ETH((ULONG) DapiHandle, moduleID, moduleNr&15, exbuffer);
			
			if(ret!=0) 
			{
				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/bus_ETH");
				sprintf(debug_msg, "DapiOpenModuleIntern - return=0 - No module found");
				debug_error(debug_msg);
				// -----
				
				DapiSetError(DAPI_ERR_DEVICE_NOT_FOUND, 0, NULL, __FILE__, __LINE__);					

				return 0;	// Connection to Module failed
			}
		}
	#endif
	
	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet-Intern (Queue)
	
	#ifdef USE_ETH_INTERN
		if(DapiHandle->BusType == bus_ETH_INTERN)
		{
			ret = DapiOpenModuleIntern_ETH_INTERN((ULONG) DapiHandle, moduleID, moduleNr&15);
			
			if(ret!=0) 
			{
				// DEBUG
				debug_set_function_name("DapiOpenModuleIntern/bus_ETH_INTERN");
				sprintf(debug_msg, "DapiOpenModuleIntern - return=0 - No module found");
				debug_error(debug_msg);
				// -----
				
				DapiSetError(DAPI_ERR_DEVICE_NOT_FOUND, 0, NULL, __FILE__, __LINE__);					

				return 0;	// Connection to Module failed
			}
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	
	DapiClearLastError();

	DapiHandle->ProgramName[0] = 0;				// Clear Prog.Name

	// DEBUG
	debug_set_function_name("DapiOpenModuleIntern");
	sprintf(debug_msg,"DapiHandle->id            = 0x%lx", DapiHandle->id);										debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->ftHandle      = 0x%lx", (ULONG) DapiHandle->ftHandle);						debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->TCPHandle     = 0x%lx", DapiHandle->TCPHandle);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->TCPHandle_tx  = 0x%lx", DapiHandle->TCPHandle_tx);							debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->moduleID      = 0x%lx #####  %s  #####", DapiHandle->moduleID, moduleName);	debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->moduleNr      = 0x%lx", DapiHandle->moduleNr);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->SubDevice     = 0x%lx - %s", DapiHandle->SubDevice, DapiHandle->SubDevice==DapiModuleID_Device?"NormalDevice":"ProgDevice"); debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->jobID         = 0x%lx", DapiHandle->jobID);									debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->BusType       = 0x%lx", DapiHandle->BusType);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->ComPort       = 0x%lx", DapiHandle->ComPort);								debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->RS485_ModuleNr= 0x%lx", DapiHandle->RS485_ModuleNr);							debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->retry         = 0x%lx", DapiHandle->retry);									debug_info(debug_msg);
	sprintf(debug_msg,"DapiHandle->timeout       = %ld dez", DapiHandle->timeout);								debug_info(debug_msg);
	// -----
	
	
	if((DapiHandle->SubDevice == DapiModuleID_DeviceProg) || ((moduleNr&0x8000) != 0))
	{
		// ----------------------------
		// DEBUG
		debug_set_function_name("DapiOpenModuleIntern");
		
		sprintf(debug_msg,"check_module_config wird NICHT DURCHGEFHRT ***** DapiModuleID_DeviceProg-Mode");
		debug_info(debug_msg);

		DapiModuleParams->sw_class			= 0;
		DapiModuleParams->hw_group			= 0;
		DapiModuleParams->sw_feature1		= 0;
		DapiModuleParams->hw_interface1		= 0;

		// -----
		// ----------------------------
	}
	else
	{
		if (restart_check_module_config((unsigned long) DapiHandle) != RETURN_OK)
		{
			return 0;// Return Handle=0 wegen Error
		}
	}

	
	// DEBUG
	debug_set_function_name("DapiOpenModuleIntern");

	sprintf(debug_msg,"Funktion-Ende / return=0x%lx", (ULONG) DapiHandle);	
	debug_info(debug_msg);
	// -----
	
	return (unsigned long) DapiHandle;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModule(ULONG moduleID, ULONG moduleNr)
{
	ULONG ret;
	char debug_msg[200];
	
	// DEBUG
	debug_set_function_name("DapiOpenModule");
	sprintf(debug_msg, "DapiOpenModule(0x%lx, 0x%lx)", moduleID, moduleNr);
	debug_info(debug_msg);
	// -----

	DapiClearLastError();

	ret = DapiOpenModuleIntern(moduleID, moduleNr, DapiModuleID_Device, (unsigned char*) 0, 0);

	// DEBUG
	debug_set_function_name("DapiOpenModule");
	sprintf(debug_msg, "return = 0x%lx", ret);
	debug_info(debug_msg);
	// -----
	
/*	if(ret!=0) 
	{
		DapiClearLastError();
	}
*/
	return ret;	
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiOpenModuleEx(ULONG moduleID, ULONG moduleNr, unsigned char* exbuffer, ULONG open_options)
{
	ULONG ret;
	char debug_msg[200];
	
	// DEBUG
	debug_set_function_name("DapiOpenModuleEx");
	sprintf(debug_msg, "DapiOpenModuleEx(0x%lx, 0x%lx, 0x%lx, options=0x%lx)", moduleID, moduleNr, (unsigned long) exbuffer, open_options);
	debug_info(debug_msg);
	// -----
	
	ret = DapiOpenModuleIntern(moduleID, moduleNr, DapiModuleID_Device, exbuffer, open_options);

	// DEBUG
	debug_set_function_name("DapiOpenModuleEx");
	sprintf(debug_msg, "return = 0x%lx", ret);
	debug_info(debug_msg);
	// -----
	
	if(ret!=0) 
	{
		DapiClearLastError();
	}

	return ret;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiCloseModule(ULONG handle)
{
	DAPI_HANDLE *DapiHandle;
	DAPI_MODULE_PARAMS *DapiModuleParams;
	char debug_msg[200];

	if((handle==0) || (handle==-1)) 
	{
		return -1;
	}

	DapiHandle = (DAPI_HANDLE*) handle;
	DapiModuleParams = (DAPI_MODULE_PARAMS *) DapiHandle->addr_dapi_module_params;

	// DEBUG
	debug_set_function_name("DapiCloseModule");
	sprintf(debug_msg, "DapiCloseModule(0x%lx) ***************************************************", handle);
	debug_info(debug_msg);
	debug_info(debug_msg);
	debug_info(debug_msg);
	// -----

	// check if handle is correct
	if(DapiCheckHandle(handle) != 0) 
	{
		// DEBUG
		debug_set_function_name("DapiCloseModule");
		sprintf(debug_msg, "DapiCloseModule - ERROR * DapiCheckHandle(handle) != 0");
		debug_error(debug_msg);
		// -----
		
		return 0;
	}

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// FTDI
	
	#ifdef USE_FTDI
		if((DapiHandle->BusType == bus_FTDI_DUAL) || (DapiHandle->BusType == bus_FTDI_SINGLE))
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "FT_Close(0x%lx)  -Bus-Typ = bus_FTDI", (unsigned long) DapiHandle->ftHandle);
			debug_info(debug_msg);
			// -----
			
			FT_Close(DapiHandle->ftHandle);
			DapiHandle->ftHandle = (FT_HANDLE) -1;		// Clear Handle
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// FTDI
	
	#ifdef USE_FTDI_SER
		if(DapiHandle->BusType == bus_SeriellCOM)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "DapiSeriellCOMCloseComPort(0x%lx) - Bus-Typ = bus_SeriellCOM", (unsigned long) (DapiHandle->ComPort));
			debug_info(debug_msg);
			// -----
			
			DapiSeriellCOMCloseComPort(DapiHandle->ComPort);
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Seriell ber FTDI
	
	#ifdef USE_FTDI
		if(DapiHandle->BusType == bus_SeriellFTDI)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "FT_Close(0x%lx)  -Bus-Typ = bus_SeriellFTDI", (unsigned long) DapiHandle->ftHandle);
			debug_info(debug_msg);
			// -----
		
			FT_Close(DapiHandle->ftHandle);
			DapiHandle->ftHandle = (FT_HANDLE) -1;		// Clear Handle
		}
	#endif
	
	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet

	#ifdef USE_ETH
		if(DapiHandle->BusType == bus_ETH)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "tcp_tx_close(0x%lx)  -Bus-Typ = bus_ETH", DapiHandle->TCPHandle, DapiHandle->TCPHandle);
			debug_info(debug_msg);
			// -----
		
			DapiCloseModuleIntern_ETH(handle);
		}
	#endif
	
	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	// Ethernet-Intern (Queue)
	
	#ifdef USE_ETH_INTERN
		if(DapiHandle->BusType == bus_ETH_INTERN)
		{
			// DEBUG
			debug_set_function_name("DapiCloseModule");
			sprintf(debug_msg, "DapiCloseModuleIntern_ETH_INTERN(0x%lx)  -Bus-Typ = bus_ETH_INTERN", handle);
			debug_info(debug_msg);
			// -----
		
			DapiCloseModuleIntern_ETH_INTERN(handle);
		}
	#endif

	// ----------------------------------------------------
	// ----------------------------------------------------
	// ----------------------------------------------------
	
	DapiClearLastError();
	
	free(DapiModuleParams);

	#ifdef __linux__
		free(DapiHandle);
	#endif	
	
	return 0;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiGetDELIBVersion(ULONG mode, ULONG par)
{
	if(mode==0) 
	{
		return (DELIB_VERSION);
	}
	else if(mode==1) 
	{
		#if (_MSC_VER >= 1500)	// >= Visual Studio 2008
			return 64;	// 64 Bit DELIB
		#else
			return 32;	// 32 Bit DELIB
		#endif

	}
	else
	{
		return 0;
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void DapiInternCloseAllSubmodules(ULONG moduleID)
{
	#ifndef linux
		ULONG i;
		ULONG handle;
		char debug_msg[200];

		for(i=0;i!=MAX_NO_OF_SAME_MODULES;++i)
		{
			// DEBUG
			debug_set_function_name("DapiInternCloseAllSubmodules");
			sprintf(debug_msg, "DapiInternCloseAllSubmodules i=%d", i);
			debug_info(debug_msg);
			// -----
		
			// Close Submodule		
			handle = (ULONG)  HandleMGR_get_handle_pointer(moduleID, i, 0);	// Subdevice = 0
			handle = (ULONG)  HandleMGR_get_handle_pointer(moduleID, i, 1);	// Subdevice = 1
			
			// DEBUG
			debug_set_function_name("DapiInternCloseAllSubmodules");
			sprintf(debug_msg, "DapiInternCloseAllSubmodules handle=%d", handle);
			debug_info(debug_msg);
			// -----
			
			DapiCloseModule(handle);
		}
	#endif
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
