//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_set_get_error.cpp
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2013
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// DEBUG OUTPUT 
//#define DEBUG_OUTPUT		1				// Ausgabe aktivieren (nur fr diese CPP-Datei)
// ACHTUNG !!!! - DAS IST HIER NICHT realisiert .....DEBUG_OUTPUT wird hier nicht benutzt !
// ------------------------------------

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History



// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------

// DapiSetError
// DapiClearLastError
// DapiGetLastErrorText
// DapiGetLastError

// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

//#include <stdlib.h>
#include <stdio.h>

#define PROGRAM_NAME_IGNORE 1

#include "proj_config.h"

#ifdef __linux__
	// LINUX ---------------
	// LINUX ---------------
	// LINUX ---------------
	#ifdef USE_FTDI
		#include "../usb/ftd2xx.h"
	#endif

	#include "library/delib/delib.h"
#else
	// WINDOWS ---------------
	// WINDOWS ---------------
	// WINDOWS ---------------
	#include <windows.h>
	#include "conio.h"
	#include "library/delib/delib.h"
#endif

// ------------------------------------
// ------------------------------------
// DELIB-DEBUG
// ------------------------------------
// ------------------------------------
//
// Function															Windows (DEBUGVIEW)			Linux
// -------------------------										----------------------		-------------------------
// DapiSetError(debug_msg)											immer						immer
// debug_error(debug_msg)											immer						immer
// debug_info(debug_msg)											immer						nur bei DEBUG_OUTPUT
// debug_print(debug_msg)											nur bei DEBUG_OUTPUT		nur bei DEBUG_OUTPUT

// ------------------------------------
// ------------------------------------
// Global Vars
// ------------------------------------
// ------------------------------------

typedef struct xxDAPI_ERROR
{
	ULONG errorcode;
	ULONG lasterror;
	char errortext[1000];
	char filename[255];
	ULONG suberror;
	ULONG line;
} DAPI_ERROR;

DAPI_ERROR lasterror;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiSetError(ULONG errorcode, ULONG suberror, char *errortext, char * filename, ULONG line)
{
	char debug_msg[1000];
	char text[500];

	sprintf(text, "");		// Clear Text

	lasterror.errorcode = errorcode;
	lasterror.lasterror = errorcode;

	if(errortext==NULL)
	{
		switch(errorcode)
		{
			case DAPI_ERR_DEVICE_NOT_FOUND:
				sprintf(text, "(auto text) Device not found");
				break;

			case DAPI_ERR_COMMUNICATION_ERROR:	
				sprintf(text, "(auto text) Communication Error");
				break;

			case DAPI_ERR_ILLEGAL_HANDLE:
				sprintf(text, "(auto text) Illegal Handle");
				break;

			case DAPI_ERR_FUNCTION_NOT_DEFINED:
				sprintf(text, "(auto text) Function not defined");
				break;

			case DAPI_ERR_ILLEGAL_COM_HANDLE:
				sprintf(text, "(auto text) Illegal COM-Handle");
				break;

			default:
				sprintf(text, "(auto text) unknown errorcode");
				break;
		}
	}
	else
	{
		sprintf(text, "DELIB Error  = %s", errortext);
	}
	
	// DEBUG
	//debug_set_function_name("DapiSetError");
	// Darf hier nicht rein, sonst sieht man nicht, woher der Error kam !

	sprintf(lasterror.errortext, "%s", text);
	
	sprintf(debug_msg, "%s", text);
	debug_error(debug_msg);

	sprintf(debug_msg, "errorcode = %d.%d", (unsigned int) errorcode, (unsigned int) suberror);
	debug_error(debug_msg);
	
	sprintf(debug_msg, "filename = %s * line = %d", filename, (unsigned int) line);
	debug_error(debug_msg);
	
	sprintf(debug_msg, "DapiSetError(%d, %d) errtext=%s, filename=%s, line = %d", (unsigned int) errorcode, (unsigned int) suberror, errortext, filename, (unsigned int) line);
	debug_error(debug_msg);
	
	sprintf(debug_msg, "DapiSetError lasterror.errortext=%s", lasterror.errortext);
	debug_error(debug_msg);
	// -----
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 void DAPI_FUNCTION_PRE DapiClearLastError()
{
	lasterror.lasterror=0;
	lasterror.errorcode=0;
	
	return;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiGetLastErrorText(unsigned char * msg_ret, unsigned long msg_length)
{
	ULONG i;
	char debug_msg[1000];

	// DEBUG
	debug_set_function_name("DapiGetLastErrorText");
	
	sprintf(debug_msg, "(msg_length=%d)", (unsigned int) msg_length);
	debug_error(debug_msg);
	sprintf(debug_msg, "lasterror.errortext=%s * strlen=%d",  (char*) lasterror.errortext, strlen_n(lasterror.errortext, sizeof(lasterror.errortext)));
	debug_error(debug_msg);
	// -----
	
	for(i=0;i!=strlen_n(lasterror.errortext, sizeof(lasterror.errortext));++i)
	{
		if(i<msg_length)
		{
			*(msg_ret + i) = *(lasterror.errortext + i);
		}
	}

	if(i<msg_length) 
	{
		*(msg_ret + i) = 0;
	}
	
	return 0;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

DAPI_FUNCTION_PRE64 ULONG DAPI_FUNCTION_PRE DapiGetLastError()
{
	return lasterror.lasterror;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
