//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	dt_communication_paramams.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2013
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
/*
// ----------------------------------------------------------------------------
// SOFTWARE Features for the module
#define SW_FEATURE_TYPE_OF_MODULE_IDENTIFICATION	(1<<0)			// Bit 0
#define SW_FEATURE_DI_DO_DX_CHANNELS				(1<<1)			// Bit 1
#define SW_FEATURE_AD_DA_CHANNELS					(1<<2)			// Bit 2

#define HW_FEATURE_TYPE_RO							(1<<0)			// Bit 0
#define HW_FEATURE_TYPE_LOGICANALYZER				(1<<1)			// Bit 1
#define HW_FEATURE_TYPE_DI_DO_AD_DA					(1<<2)			// Bit 2
#define HW_FEATURE_TYPE_USB							(1<<3)			// Bit 3
#define HW_FEATURE_TYPE_BS							(1<<4)			// Bit 4
#define HW_FEATURE_TYPE_NET							(1<<5)			// Bit 5
*/
/*
// ----------------------------------------------------------------------------
// DELIB-ID's fuer div. Spannungsbereiche
#define ADDA_MODE_UNIPOL_10V									0x00
#define ADDA_MODE_UNIPOL_5V										0x01
#define ADDA_MODE_UNIPOL_2V5									0x02

#define ADDA_MODE_BIPOL_10V										0x40
#define ADDA_MODE_BIPOL_5V										0x41
#define ADDA_MODE_BIPOL_2V5										0x42

#define ADDA_MODE_0_20mA										0x80
#define ADDA_MODE_4_20mA										0x81
#define ADDA_MODE_0_24mA										0x82
//#define ADDA_MODE_0_25mA										0x83
#define ADDA_MODE_0_50mA										0x84
*/
// ----------------------------------------------------------------------------
#define DT_FTDI_USB_CMD_PING		0x12
#define DT_FTDI_USB_CMD_SEND8BYTE	0x23
#define DT_FTDI_USB_CMD_GET8BYTE	0x34
#define DT_FTDI_USB_CMD_SENDNBYTE	0x45
#define DT_FTDI_USB_CMD_GETNBYTE	0x56

// ----------------------------------------------------------------------------
#define CAN_CMD_REG_READ	0x10
#define CAN_CMD_REG_WRITE	0x20
#define CAN_CMD_GET_INFO	0xf0

// ----------------------------------------------------------------------------
#define CAN_DATA_NOTHING	0x00
#define CAN_DATA_BIT		0x01
#define CAN_DATA_BYTE		0x02
#define CAN_DATA_WORD		0x03
#define CAN_DATA_LONG		0x04

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// RO-Modules-REGISTER
// --------------------
// Registerbelegung:
// Register 0x00-0x0f (write)- Ausgnge
// Register 0x00-0x0f (read) - Ausgnge zurcklesen

// Register 0x20-0x2f (read)- Eingnge
// Register 0x40-0x4f (read)- Eingangs-FF's (incl. Zurcksetzen)

// Register 0xf0 - Config Timeout (0=disabled, 1-255 sind Zeit-Werte)
// Register 0xf1 - Config ???

// Register 0xfff8-fffe	8Bit readback Register (zum Test)
// Register 0xfff4-fff7		32 Bit Firmware-Version
// Register 0xfff0-fff3		32 Bit SW-Feature Bits (Type of Software Features)
// Register 0xffec-ffef		32 Bit HW-Feature Bits (Type of Hardware)
// Register 0xff00-ff01		16 Bit No of DO Chan 
// Register 0xff02-ff03		16 Bit No of DI Chan 
// Register 0xff04-ff05		16 Bit No of DX Chan 
// Register 0xff06-ff07		16 Bit No of AD Chan 
// Register 0xff08-ff09		16 Bit No of DA Chan 
// Register 0xff0a-ff0b		16 Bit No of Stepper Chan 

// 0xffd0-df		: Gibt die Modul-Identifikations-Nummer des Moduls zurck
// Fr den Direktzugriff auf die einzelnen Module

// 0xfe00			: Modul-Nummer, auf die geschrieben werden soll
// 0xfe02			: Register, auf das geschrieben werden soll
// 0xfe03			: Daten, die geschrieben werden sollen 
// 0xfe04+5			: Daten, die gelesen werden

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// 8 Bytes CAN-Data Command zum Modul
// ----------------------------------
// 1.Byte = Command
// 2.Byte = Register Bit 0-7
// 3.Byte = Register Bit 8-15
// 4.Byte = JOB-ID
// 5.Byte = Data (0-7)
// 6.Byte = Data (8-15)
// 7.Byte = Data (16-23)
// 8.Byte = Data (24-31)

// Command = (0x10=read,0x20=write,0xf0=get info) 	OR gewnschte Datenbits (0=nix,1=Bit,2=Byte,3=Word,4=Long)

// 8 Bytes CAN-Data ANTWORT vom Modul
// ----------------------------------
// 1.Byte = 1 = OK, 0xfd=JOB-ID nochmals vorhanden, 0xfe Befehl ungltig
// 2.Byte = Was ist an EMPFANGENEN Daten gltig (0=nix, 1=Bit, 2=Byte, 3 Word, 4=Long)
// 3.Byte = JOB-ID
// 4.Byte = Data (0-7)
// 5.Byte = Data (8-15)
// 6.Byte = Data (16-23)
// 7.Byte = Data (24-31)


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// Protokoll fr Serielle Kommandos
//								Daten 	*	Seriell bertragen in hex	*	ASCII
// 1.Zeichen = <SOH>			<SOH>	*	0x01						*	<SOH>
// 2.Zeichen = MODUL-NR			0x34	*	0x33, 0x34					*	(34)
// 2.Zeichen = JOB-ID			0x12	*	0x31, 0x32					*	(12)
// 3.Zeichen = COMMAND			'W'		*	0x57						*	(W)
// 3.Zeichen = WIDTH			'B'		*	0x42						*	(B)
// 4.Zeichen = Adresse			0x00	*	0x30, 0x30					*	(00)
// 5.Zeichen = Adresse			0x12	*	0x31, 0x32					*	(12)
// 6.Zeichen = Daten			0x0f	*	0x30, 0x46					*	(0F)
// 7.Zeichen = Checksumme		Summe	*	0x33, 0x41					*	(3A) (Summe=0x23a -> (nur 8 Bit -> 0x3a)
// 8.Zeichen = <CR>				0x0d	*	0x0d						*	<CR>


// COMMAND'S : W = write, R=read
// Command=W,R greift auf Register zu

// WIDTH= B -> Byte		(-> es folgen 2 Bytes fr Daten)
// WIDTH= W -> 16 Bit	(-> es folgen 4 Bytes fr Daten)
// WIDTH= L -> 32 Bit	(-> es folgen 8 Bytes fr Daten)
// WIDTH= X -> 64 Bit	(-> es folgen 16 Bytes fr Daten)
// WIDTH= M -> 128 Bit	(-> es folgen 32 Bytes fr Daten)

#define SERIELL_CMD_WIDTH_8		'B'
#define SERIELL_CMD_WIDTH_16	'W'
#define SERIELL_CMD_WIDTH_32	'L'
#define SERIELL_CMD_WIDTH_64	'X'
#define SERIELL_CMD_WIDTH_128	'M'

#define ERR_EXECUTE_RS232_RX_COMMAND_OK                  0
#define ERR_EXECUTE_RS232_RX_COMMAND_ILLEGAL_COMMAND     1
#define ERR_EXECUTE_RS232_RX_COMMAND_WRONG_DATA_LENGTH   2
#define ERR_EXECUTE_RS232_RX_COMMAND_WRONG_CHECKSUM      3
#define ERR_EXECUTE_RS232_RX_COMMAND_NOT_FOR_ME			 4

// ----------------------------------------------------------------------------
// RO-SPI->CPU Commands

#define RO_CPU_CMD_MODULE_COUNTER_LATCH						0x7c		// Latch Counter, if Data = 0x3a
#define RO_CPU_CMD_MODULE_COUNTER_LATCH_VALUE				0x3a		// Latch Counter, if Data = 0x3a
#define RO_CPU_CMD_MODULE_COUNTER_LATCH_WITH_RESET_VALUE	0x3d		// Latch Counter WITH RESET , if Data = 0x3d

#define RO_CPU_CMD_MODULE_TIMEOUT_SHUT_OFF			0x7d		// Deactivate Module, if Data = 0x49
#define RO_CPU_CMD_MODULE_TIMEOUT_SHUT_OFF_VALUE	0x49		// Deactivate Module, if Data = 0x49

#define RO_CPU_CMD_WRITE_TO_BOOTLOADER	0x7e		// Write data to bootloader
#define RO_CPU_CMD_GO_BOOTLOADER		0x7f		// Jump to Bootloader if Data = 0x83
#define RO_CPU_CMD_GO_BOOTLOADER_VALUE	0x83		// Jump to Bootloader if Data = 0x83

#define RO_CPU_CMD_FIFO_WRITE_ADDR_REG	0x76		// Write to Fito-Addr reg
#define RO_CPU_CMD_FIFO_WRITE_FIFO_CMD	0x77		// Write Fifo Command and execute this command

#define RO_CPU_CMD_OPTION_FILTER		0x78		// 0=disable filter / 1 = enable filter

#define RO_CPU_CMD_SET_EEPROM_DATA		0x79		// Set EEPROM Data
#define RO_CPU_CMD_SET_EEPROM_ADRESSL	0x7a		// Set EEPROM AdressLow
#define RO_CPU_CMD_SET_EEPROM_ADRESSH	0x7b		// Set EEPROM AdressHigh + Initiere EEPROM Write

#define RO_CPU_CMD_FIFO_GET_ADDR_REG	0xf0		// Get Fifo Status
#define RO_CPU_CMD_FIFO_GET_CMD_ANSW	0xf1		// Get Fifo Status
#define RO_CPU_CMD_FIFO_GET_STATUS		0xf2		// Get Fifo Status
#define RO_CPU_CMD_FIFO_READ_DATA		0xf3		// Get Fifo Data

#define RO_CPU_CMD_GET_ERROR_CODE		0xf6		// Get ERROR Code
#define RO_CPU_CMD_GET_FIRMWARE_ID		0xf7		// Get Firmware ID

#define RO_CPU_CMD_GET_V0				0xf8		// Get Version Nr 0
#define RO_CPU_CMD_GET_V1				0xf9		// Get Version Nr 1
#define RO_CPU_CMD_GET_V2				0xfa		// Get Version Nr 2
#define RO_CPU_CMD_GET_V3				0xfb		// Get Version Nr 3

#define RO_CPU_CMD_GET_ID				0xfc		// Get Module-ID Info

#define RO_CPU_CMD_GET_CONFIG			0xfd		// Bit 0 = Bootloader, Bit 1 = OP_X2 Bit 

#define RO_CPU_CMD_READ_FROM_BOOTLOADER	0xfe		// Give back data from bootloader
#define RO_CPU_CMD_GIVE_BACK			0xff		// Give the written Data back

// ----------------------------------------------------------------------------

#define RO_COMM_RETURN_OK 			0x01
#define RO_COMM_RETURN_REG_INVALID	0xfe
#define RO_COMM_RETURN_ERROR 		0xff

// ----------------------------------------------------------------------------
// Bootloader_id
#define RO_BOOTLOAD_ID_RO_SER		0x00
#define RO_BOOTLOAD_ID_RO_CAN		0x01
#define RO_BOOTLOAD_ID_RO_AD16DA4	0x02
#define RO_BOOTLOAD_ID_RO_DA2_ISO	0x03
#define RO_BOOTLOAD_ID_RO_STEPPER2	0x04
#define RO_BOOTLOAD_ID_RO_Ox_Rx		0x05
#define RO_BOOTLOAD_ID_RO_PT100		0x06
#define RO_BOOTLOAD_ID_RO_CNT8		0x07

#define BOOTLOAD_ID_USB_TTL_64		0x80
#define RO_BOOTLOAD_ID_RO_USB2		0x81

// ----------------------------------------------------------------------------
// RO-SPI Commands
#define RO_CPU_ID_DA2			1
#define RO_CPU_ID_AD16_DA4		2
#define RO_CPU_ID_AD16			3
#define RO_CPU_ID_DA4			4
#define RO_CPU_ID_AD16_ISO		5
#define RO_CPU_ID_STEPPER2		6
#define RO_CPU_ID_O8_R8			7
#define RO_CPU_ID_PT100			8
#define RO_CPU_ID_CNT_8			9
#define RO_CPU_ID_CNT_IGR		10
#define RO_CPU_ID_DA8			11
#define RO_CPU_ID_MOS16			12
#define RO_CPU_ID_MOS16_PWM		13
#define RO_CPU_ID_R8_UM			14

#define RO_CPU_ID_OUTPUT	0xf0
#define RO_CPU_ID_INPUT		0xf1
// ----------------------------------------------------------------------------
#define LED_BLINK_SHORT	10		// 10 ms to blink short

// Special RO-Functions
#define SPECIAL_COMMAND_FLASH_ERASE_0	1
#define SPECIAL_COMMAND_FLASH_ERASE_1	2
#define SPECIAL_COMMAND_REBOOT			3
#define SPECIAL_COMMAND_RESCAN			4

// RO-FIFO Commands
#define RO_FIFO_CMD_fifo_init 			1
#define RO_FIFO_CMD_fifo_set_intervalL	2
#define RO_FIFO_CMD_fifo_set_intervalH	3
#define RO_FIFO_CMD_fifo_enable_chL		4
#define RO_FIFO_CMD_fifo_enable_chH		5
#define RO_FIFO_CMD_fifo_enable_disable	6

// RO-FIFO Status
#define RO_FIFO_STATUS_MASK_MEASURE_ENABLED	 0x80
#define RO_FIFO_STATUS_MASK_TEST_DATA		 0x40
#define RO_FIFO_STATUS_MASK_OVERFLOW		 0x20
#define RO_FIFO_STATUS_MASK_UNDERRUN		 0x10
#define RO_FIFO_STATUS_FULL_256_BYTE		 0x08
#define RO_FIFO_STATUS_FULL_64_BYTE			 0x04
#define RO_FIFO_STATUS_FULL_16_BYTE			 0x02
#define RO_FIFO_STATUS_FULL_1_BYTE			 0x01

#define RO_FIFO_ID_START 0xf0
#define RO_FIFO_ID_END 	0xf1
#define RO_FIFO_ID_TYPE_TEST1	0xfe
#define RO_FIFO_ID_TYPE_AD16M0	0x01


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// EEPROM Filesystem
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// ------------------------------------
// Filesystem ID
#define DT_EE_FILESYSTEM_ID									0x95acd43f

// ------------------------------------
// Filesystem Directory Types
#define DT_EE_FILESYSTEM_DIR_TYPE_EMPTY						0xff
#define DT_EE_FILESYSTEM_DIR_TYPE_CONFIG					0x01

// ------------------------------------
// Filesystem Commands
#define DT_EE_FILESYSTEM_CMD_READ							0x01
#define DT_EE_FILESYSTEM_CMD_WRITE							0x02
#define DT_EE_FILESYSTEM_CMD_GET_DIR_ENTRIES				0x03



