
#include <stdio.h>
#include <string.h>
#include "../embedded/dt_var_defines.h"

//extern BOOL IsError();

#define MODE_WRITE_ANZAHL	5
#define MODE_READ_ANZAHL	5

// muss sein, wegen longlong
extern unsigned long long DapiReadLongLong(unsigned long handle, unsigned long adress);

char type_str[40];

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void write_byte(unsigned long handle, unsigned long adress, unsigned long mode, unsigned long anz, unsigned char * data)
{
	unsigned long i;

	switch(mode)
	{
		// --------------------------------------
		case 1:
			// 8 Bit
			debug_error("WRITE mit 8-er Befehlen\n");
			for(i=0;i<anz;i+=1)
			{
				DapiWriteByte(handle, adress + i, *(data + i));
				IsError();
			}
			break;
		// --------------------------------------
		case 2:
			// 16 Bit
			debug_error("WRITE mit 16-er Befehlen\n");
			for(i=0;i<anz;i+=2)
			{
				DapiWriteWord(handle, adress + i, *(data + i) | (*(data + i +1) <<8));
				IsError();
			}
			break;
		// --------------------------------------
		case 3:
			// 32 Bit
			debug_error("WRITE mit 32-er Befehlen\n");
			for(i=0;i<anz;i+=4)
			{
				DapiWriteLong(handle, adress + i, *(data + i) | (*(data + i +1) <<8) | (*(data + i + 2) <<16) | (*(data + i + 3) <<24));
				IsError();
			}
			break;
		// --------------------------------------
		case 4:
			// 64 Bit
			debug_error("WRITE mit 64-er Befehlen\n");
			for(i=0;i<anz;i+=8)
			{
				DapiWriteLongLong(handle, adress + i, (unsigned long long) ((unsigned long long) *(data + i) | ((unsigned long long) *(data + i + 1) <<8) | ((unsigned long long) *(data + i + 2) <<16) | ((unsigned long long) *(data + i + 3) <<24) | ((unsigned long long) *(data + i + 4) <<32) | ((unsigned long long) *(data + i + 5) <<40) | ((unsigned long long) *(data + i + 6) <<48) | ((unsigned long long) *(data + i + 7) <<56)));
				IsError();
			}
			break;
		// --------------------------------------
		case 5:
			// 8 Bit Multiple Byte
			debug_error("WRITE mit MultipleByte Befehl\n");
			DapiWriteMultipleBytes(handle, adress, anz, 1, data, anz);
			IsError();
	//getch();
			break;
		// --------------------------------------
	}
	//DapiWriteByte(handle, 0xfff0, 0);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void read_byte(unsigned long handle, unsigned long adress, unsigned long mode, unsigned long anz, unsigned char * data)
{
	unsigned long i;

	unsigned long ret;
	unsigned long long ret_ll;

	switch(mode)
	{
		// --------------------------------------
		case 1:
			// 8 Bit
			sprintf(type_str, "READ mit  8-er Befehlen       ");
			for(i=0;i<anz;i+=1)
			{
				*(data + i) = (unsigned char) DapiReadByte(handle, adress + i);
				IsError();
			}
			break;
		// --------------------------------------
		case 2:
			// 16 Bit
			sprintf(type_str, "READ mit 16-er Befehlen       ");
			for(i=0;i<anz;i+=2)
			{
				ret = DapiReadWord(handle, adress + i);
				IsError();
				*(data+i+0) = (unsigned char) ret & 255;
				*(data+i+1) = (unsigned char) (ret>>8) & 255;
			}
			break;
		// --------------------------------------
		case 3:
			// 32 Bit
			sprintf(type_str, "READ mit 32-er Befehlen       ");
			for(i=0;i<anz;i+=4)
			{
				ret = DapiReadLong(handle, adress + i);
				IsError();
				*(data+i+0) = (unsigned char)  ret      & 255;
				*(data+i+1) = (unsigned char) (ret>> 8) & 255;
				*(data+i+2) = (unsigned char) (ret>>16) & 255;
				*(data+i+3) = (unsigned char) (ret>>24) & 255;
			}
			break;
		// --------------------------------------
		case 4:
			// 64 Bit
			sprintf(type_str, "READ mit 64-er Befehlen       ");
			for(i=0;i<anz;i+=8)
			{
				ret_ll = DapiReadLongLong(handle, adress + i);

				IsError();
				*(data+i+0) = (unsigned char) ret_ll      & 255;
				*(data+i+1) = (unsigned char) (ret_ll>> 8) & 255;
				*(data+i+2) = (unsigned char) (ret_ll>>16) & 255;
				*(data+i+3) = (unsigned char) (ret_ll>>24) & 255;
				*(data+i+4) = (unsigned char) (ret_ll>>32LL) & 255;
				*(data+i+5) = (unsigned char) (ret_ll>>40LL) & 255;
				*(data+i+6) = (unsigned char) (ret_ll>>48LL) & 255;
				*(data+i+7) = (unsigned char) (ret_ll>>56LL) & 255;
			}
			break;
		// --------------------------------------
		case 5:
			// 8 Bit Multiple Byte
			sprintf(type_str, "READ mit MultipleByte Befehl  ");
			DapiReadMultipleBytes(handle, adress, anz, 1, data, anz);
			IsError();
	//getch();
			break;
		// --------------------------------------

	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long test_readbackAllModes(unsigned long handle, bool debug_flag)
{
	int i;
	unsigned char ch=0;
	unsigned long offset=0xfff8;

	unsigned long err;
	unsigned long err_total;

	unsigned long mode_write;
	unsigned long mode_read;

	unsigned char data_write[8];
	unsigned char data_read[8];
	
	unsigned char msg[200];
	unsigned char msg2[200];
	
	err_total=0;

	
	for(mode_write=1;mode_write<=MODE_WRITE_ANZAHL;++mode_write)
	{ // loop fr WRITE-Mode
		switch(mode_write)
		{
			case 1:	for(i=0;i<8;i+=1) data_write[i] = (unsigned char) (0x20 + i);break;
			case 2:	for(i=0;i<8;i+=1) data_write[i] = (unsigned char) (0xff - i);break;
			case 3:	for(i=0;i<8;i+=1) data_write[i] = (unsigned char) (0x01 * i);break;
			case 4:	for(i=0;i<8;i+=1) data_write[i] = (unsigned char) (0x11 * i);break;
			case 5:	for(i=0;i<8;i+=1) data_write[i] = (unsigned char) ((0x11 * i) + 1);break;
		}
		//debug_error("XX\n");
		write_byte(handle, offset, mode_write, 8, data_write);		// Mode = 1 = 8 Bit  etc ....
		//debug_error("YY\n");
		//			debug_error("data = ");
		//			for(i=7;i>=0;--i)
		//			{
		//				debug_error("%2x ", data_write[i]);
		//			}
		//		debug_error("Write ende\n");getch();

		for(mode_read=1;mode_read<=MODE_READ_ANZAHL;++mode_read)
		{ // loop fr READ-Mode


			for(i=0;i!=8;++i) data_read[i]=0;
			read_byte(handle, offset, mode_read, 8, data_read);		// Mode = 1 = 8 Bit etc ....
//			debug_error("read ende\n");getch();
		

			sprintf(msg2, "%s", type_str);
			for(i=7;i>=0;--i)
			{
				sprintf(msg, "%2x-", data_read[i]);
				strcat_n(msg2, sizeof(msg2), msg, strlen_n(msg), sizeof(msg));
			}

			
			err=0;
			
			
			for(i=0;i!=8;++i)
			{
				if(data_write[i] != data_read[i]) ++err;
			}
			if(err==0) 
			{
				sprintf(msg, " -- ok");
				strcat_n(msg2, sizeof(msg2), msg, strlen_n(msg), sizeof(msg));
			}
			else
			{
				sprintf(msg, " -- ERROR");
				strcat_n(msg2, sizeof(msg2), msg, strlen_n(msg), sizeof(msg));
				++err_total;
			}

			if(debug_flag == TRUE)
			{
				debug_error("data = %s", msg2);	
			}

						
		} //loop read
	} // loop write

	if(err_total==0) 
	{
		if(debug_flag == TRUE)
		{
			debug_error("Alles ok, keine Fehler\n");
		}

		return RETURN_OK;
	}
	else
	{
		if(debug_flag == TRUE)
		{
			debug_error("ERROR Anzahl = %d\n", err_total);
		}

		return RETURN_ERROR;
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
